{$G+}
uses crt;
var
  font: pointer;

procedure SaveCharset(var buffer); assembler;
asm
  cli
  mov dx,03C4h
  mov ax,0402h
  out dx,ax
  mov ax,0704h
  out dx,ax
  mov dl,0CEh
  mov ax,0204h
  out dx,ax
  mov ax,0005h
  out dx,ax
  mov ax,0406h
  out dx,ax
  push ds
  push 0a000h
  pop ds
  xor si,si
  les di,buffer
  cld
  mov ax,$ff
  mov bx,32
  mul bx
  mov dx,16
  @@1:
  mov cx,dx
  rep movsb
  mov cx,bx
  sub cx,dx
  add si,cx
  sub ax,bx
  or ax,ax
  jnz @@1
  pop ds
  mov dx,03C4h
  mov ax,0302h
  out dx,ax
  mov ax,0304h
  out dx,ax
  mov dl,0CEh
  mov ax,0004h
  out dx,ax
  mov ax,1005h
  out dx,ax
  push 0040h
  pop es
  mov ax,0E06h
  cmp byte ptr es:[0049h],07h
  jne @color
  mov ax,0A06h
  @color:
  out dx,ax
  sti
end; { SaveCharset }

procedure put(x,y,where:word;c:byte); assembler;
asm
  mov ax,where
  mov es,ax
  mov ax,y
  mov bx,320
  mul bx
  add ax,x
  xchg ax,di
  mov al,c
  mov es:[di],al
end;

procedure flip386(const a,b:word); assembler;
asm
  push ds
  mov ds,a
  mov es,b
  xor si,si
  xor di,di
  mov cx,16000
  db 66h; rep movsw
  pop ds
end;

procedure clear386(const where:word;const c:byte); assembler;
asm
  mov es,where
  xor ax,ax
  xor di,di
  mov al,[c]
  mov ah,al
  db 66h; shr ax,16
  mov al,[c]
  mov ah,al
  mov cx,16000-(320*16)/4
  db 66h; rep stosw
end;

procedure setcol(c,r,g,b: byte);
begin port[$3c8]:=c; port[$3c9]:=r; port[$3c9]:=g; port[$3c9]:=b; end;

var
  vidbuf: word;
  vidbufptr: pointer;
  wave: real;

procedure vline(x1,y1,y2,col,where: word);
var i: word; begin for i:=y1 to y2 do put(x1,i,where,col); end;

procedure sincurve(height: word);
var radian: array[0..319] of word; i,yy,col: word;
begin
  for i:=10 to 309 do begin
    col:=round(i*58/319);
    yy:=round((sin(wave)*height))+40;
    vline(i,yy,yy+40,col+80,vidbuf);
    vline(i,yy+40,yy+80,col+80+58,vidbuf);
    vline(i,yy+80,yy+120,col+80+58*2,vidbuf);
    wave:=wave+0.02;
  end;
end;
procedure drawcool3(writing: string; x,y: byte; del: word);
var len,i: integer;
begin
  textcolor(0);
  len:=length(writing);
  for i:=1 to len do begin
    gotoxy(x+i-1,y);
    textcolor(7); write(copy(writing,i,1));
    textcolor(15); write(copy(writing,i+1,1));
    textcolor(11); write(copy(writing,i+2,1));
    textcolor(9); write(copy(writing,i+3,1));
    textcolor(1); write(copy(writing,i+4,1));
    textcolor(9); write(copy(writing,i+5,1));
    textcolor(11); write(copy(writing,i+6,1));
    textcolor(0); write(copy(writing,i+7,len-i));
    delay(del);
    gotoxy(x,y);
  end;
end;

const
  maxh=20;
  minh=0;
  maxwave=270-1;
const
  yo=23*8;
  color=7;
  txt:string='hello everybody. do U like this intro, i'' like to think so...'+
             '    sy,dk.                                               ';
var txtidx,curchar,pixline:byte;bitpos: shortint;
var
  col,i: byte;
  dir: shortint;
  wait,x,y: word;
  ll: longint;
  tcursor: word;
begin
  getmem(font,4096);
  getmem(vidbufptr,64000); vidbuf:=seg(vidbufptr^);
  SaveCharSet(font^);
  asm mov ax,13h; int 10h; end;
  for col:=80 to 80+58 do setcol(col,col-80,col-80,col-80);
  for col:=80+58+1 to 80+58*2 do setcol(col,0,0,col-58-1-80);
  for col:=80+58*2+2 to 80+58*3 do setcol(col,col-80-58-58-2,0,0);
  dir:=1;
  i:=minh;
  wait:=105;
  txtidx:=1;
  bitpos:=7;
  wave:=0;
  fillchar(vidbufptr^,64000,0);
  repeat
    clear386(vidbuf,0);
    if wait>50 then begin
      inc(i,1*dir);
      if i>=maxh then begin wait:=0; dir:=-1; i:=maxh-1; end;
      if i<=minh then begin dir:=1; i:=minh+1; end;
    end else
      inc(wait);
    sincurve(i);
    { draw scroll string }
    dec(bitpos);
    if bitpos<0 then begin
      curchar:=byte(txt[txtidx]); txtidx:=1+txtidx mod length(txt);
      bitpos:=7;
    end;
    for pixline:=0 to 15 do begin
      move(mem[vidbuf:(yo+pixline)*320+1],mem[vidbuf:(yo+pixline)*320+0],320);
      col:=byte(((mem[seg(font^):ofs(font^)+curchar shl 4+pixline]) shr bitpos)
        and 1)*(32+txtidx and $1f+pixline+bitpos);
      put(319,yo+pixline,vidbuf,col);
    end;
    flip386(vidbuf,$a000);
  until keypressed;
  readkey;
  asm mov ax,03h; int 10h; end;
  freemem(vidbufptr,64000);
  freemem(font,4096);
  randomize;
  asm
    mov ah,3
    mov bh,0
    int 10h
    mov tcursor,cx
    mov ah,1
    mov bh,0
    mov cx,2000h
    int 10h
  end;
  drawcool3('iNtR0 (0dEd bY *dk*',1,1,30);
  asm
    mov ah,1
    mov bh,0
    mov cx,tcursor
    int 10h
  end;
end.